using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DSK_Clean
{
    public partial class Form1 : Form
    {
        private Byte[] File_data;
        private Byte[] Result;
        private int Result_len=0;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string DSKident = "EXTENDED CPC DSK File";
            string TRACKident = "Track-Info";
            System.IO.BinaryReader DSKfile;

            textBox1.Text = "";
            button2.Enabled = false;

            // ouvre le fichier
            DialogResult res = openFileDialog1.ShowDialog();
            if (res == DialogResult.OK)
            {
                // ouvre le fichier
                if (!File.Exists(openFileDialog1.FileName))
                {
                    richTextBox1.AppendText("Impossible d'ouvrir le fichier car il n'existe pas\n");
                }
                else
                {
                    // lit le fichier en memoire
                    System.IO.FileInfo myfileinfo = new System.IO.FileInfo(openFileDialog1.FileName);
                    System.IO.FileStream myfile = myfileinfo.OpenRead();
                    DSKfile = new System.IO.BinaryReader(myfile);


                    // verifi que le fichier est bien un DSK
                    File_data = DSKfile.ReadBytes((int)myfile.Length); 
                    if (Encoding.ASCII.GetString(File_data, 0, DSKident.Length) != DSKident)
                    {
                        richTextBox1.AppendText("Le fichier n'est pas un DSK valide\n");
                    }
                    else
                    {
                        richTextBox1.AppendText("Ouverture de " + openFileDialog1.FileName + " \n");
                        textBox1.Text = openFileDialog1.FileName;
                        button2.Enabled = true;
                        saveFileDialog1.FileName = "New " + System.IO.Path.GetFileName(openFileDialog1.FileName);
                        Result = new Byte[File_data.Length];

                        

                        // recupere le nb de pistes de la source
                        int pistesnb_src = (int)File_data[48];
                        int pistesnb_dest = 0;

                        // copie de l'entte
                        Array.Copy(File_data,0,Result,0,256);

                        int position_src = 256;
                        int position_dest = 256;
                        int piste = 0;
                        while (piste <= pistesnb_src)
                        {
                            // mainenant copie des pistes si la piste n'est pas vide
                            // si on est a la fin du disque et que la derniere piste est vide
                            if (position_src + 256 >= File_data.Length)
                            {
                                richTextBox1.AppendText("Piste " + piste.ToString() + " vide\n");
                                position_src += 256;
                                Result[52 + piste] = (byte)0;
                            }
                            else
                            {
                                // si la piste est vide (il n'y a que le descripteur)
                                if (Encoding.ASCII.GetString(File_data, position_src + 256, TRACKident.Length) == TRACKident)
                                {
                                    // on vire cette piste
                                    richTextBox1.AppendText("Piste " + piste.ToString() + " vide\n");
                                    position_src += 256;
                                    Result[52 + piste] = (byte)0;
                                }
                                else
                                {
                                    // copie du track info
                                    Array.Copy(File_data, position_src, Result, position_dest, 256);
                                    position_src += 256;
                                    position_dest += 256;
                                    pistesnb_dest++;
                                    // on la garde : copie dans la destination tant qu'il y a de nvx tracks infos
                                    bool ok = false;
                                    int tracklen = 0;
                                    while (!ok)
                                    {
                                        // si c'est fini !
                                        if (position_src + TRACKident.Length >= File_data.Length)
                                        {
                                            // c'est finit : copie la fin
                                            ok = true;
                                            Array.Copy(File_data, position_src, Result, position_dest, File_data.Length - position_src);
                                            tracklen += File_data.Length - position_src;
                                            position_dest += File_data.Length - position_src;
                                        }
                                        else
                                        {
                                            if (Encoding.ASCII.GetString(File_data, position_src, TRACKident.Length) == TRACKident)
                                            {
                                                // c'est finit !
                                                ok = true;
                                            }
                                            else
                                            {
                                                Array.Copy(File_data, position_src, Result, position_dest, 1);
                                                position_src++;
                                                position_dest++;
                                                tracklen++;
                                            }
                                        }
                                    }
                                    richTextBox1.AppendText("Piste " + piste.ToString() + " - " + tracklen.ToString() + "\n");

                                }
                            }
                            piste++;
                        }
                        richTextBox1.AppendText("Termin.\n");
                        // ecrit le nouveau nb de pistes 

                        // Result[48] = (byte)pistesnb_dest; // pas besoin en fait !!
                        Result_len = position_dest;
                        richTextBox1.ScrollToCaret();
                    }
                    DSKfile.Close();
                }



            }
        }

        private void button2_Click(object sender, EventArgs e)
        {

            DialogResult res = saveFileDialog1.ShowDialog();
            if (res == DialogResult.OK)
            { 
                // ok, on ce le fichier et on le sauvegarde
                // ouvre le fichier
                if (File.Exists(saveFileDialog1.FileName))
                {
                    MessageBox.Show("Le ficheir existe dj !! Impossible de sauvegarder");
                }
                else
                {
                    BinaryWriter bw = new BinaryWriter(File.Open(saveFileDialog1.FileName, FileMode.Create));

                    bw.Write(Result, 0, Result_len);
                    bw.Close();
                    richTextBox1.AppendText("Sauvegarde de  " + saveFileDialog1.FileName + "\n");

                }

            } 
        }
    }
}